package Filesystem;

public final class DirectoryI extends _DirectoryDisp implements NodeI
{
    public
    DirectoryI(String name, DirectoryI parent)
    {
        _name = name;
        _parent = parent;
        _myID = parent != null ? java.util.UUID.randomUUID().toString() : "RootDir";
    }

    public String
    id()
    {
        return _myID;
    }

    public void
    activate(Ice.ObjectAdapter adapter)
    {
        // MISSING
        // Activate the servant so this node is added to the ASM.
        //
        // Add this new node to its parent directory (unless the
        // new node is the root directory). Use the addChild()
        // method to add this node to the parent's _contents
        // map.
    }

    public String
    name(Ice.Current c)
    {
        return _name;
    }

    public NodeDetails[]
    list(Ice.Current c)
    {
        // MISSING implement the body of this operation
        return null;
    }

    public void
    addChild(String name, NodeI child)
    {
        _contents.put(name, child);
    }

    private String _name;
    private DirectoryI _parent;
    private String _myID;
    private java.util.HashMap<String, NodeI> _contents = new java.util.HashMap<String, NodeI>();
}
