package Filesystem;

public class FileI extends _FileDisp
{
    public
    FileI(String name, DirectoryI parent, Ice.ObjectAdapter adapter)
    {
        assert(parent != null);

        _name = name;
        _myID = java.util.UUID.randomUUID().toString();
        _parent = parent;
        parent.addChild(_myID, this);
        adapter.add(this, adapter.getCommunicator().stringToIdentity(_myID));
    }

    public synchronized String
    name(Ice.Current c)
    {
        return _name;
    }

    public void
    destroy(Ice.Current c)
    {
        // MISSING
    }

    public synchronized String[]
    read(Ice.Current c)
        throws IOError
    {
        return _lines;
    }

    public synchronized void
    write(String[] text, Ice.Current c)
        throws IOError
    {
        _lines = text;
    }

    public String _name; // Public for use by _parent
    public String _myID; // Public for use by _parent

    private DirectoryI _parent;
    private String[] _lines;
}
